<template>
	<f7-page 
        name="marketplacestore" 
        @page:beforein="onPageBeforeIn"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="marketplaceProducts.length > 0" class="show-small-title">{{ marketplaceProducts[0].author.profile.store_name != null ? marketplaceProducts[0].author.profile.store_name : marketplaceProducts[0].author.profile.fullname }}</f7-nav-title>
		</f7-navbar>        
        <f7-swiper v-if="allmedias.length > 0" pagination :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
            <f7-swiper-slide class="store-has-browser" v-for="item in allmedias" v-bind:key="item.id">
                <span class="image-thumb" :style="`background-image: url(${item.url.medium});`"></span>
            </f7-swiper-slide>
        </f7-swiper> 
        <f7-swiper v-else :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
            <f7-swiper-slide>
                <span class="image-thumb" :style="`background-image:url(${require('../assets/no-photo.jpg')})`"></span>
            </f7-swiper-slide>
        </f7-swiper> 
        <f7-block class="product-detail">
            <h3 v-if="marketplaceProducts.length > 0">{{ marketplaceProducts[0].author.profile.store_name != null ? marketplaceProducts[0].author.profile.store_name : marketplaceProducts[0].author.profile.fullname }}</h3>   
            <span class="display-block" v-if="marketplaceProducts.length > 0 && marketplaceProducts[0].author.profile.store_about != null">{{ marketplaceProducts[0].author.profile.store_about }}</span> 
            <span class="display-block margin-small-top padding-small-top padding-small-bottom" style="border-top:1px dashed #ddd;border-bottom:1px dashed #ddd;" v-if="marketplaceProducts.length > 0 && marketplaceProducts[0].author.profile.store_open != null"><f7-icon f7="time" size="18px" color="green"></f7-icon> <strong>Buka</strong> dari <strong>{{ marketplaceProducts[0].author.profile.store_open }}</strong> - <strong>{{ marketplaceProducts[0].author.profile.store_close }}</strong> <span class="float-right"><f7-icon f7="placemark" size="18px" color="pink"></f7-icon> {{ distance(currentLocation.latitude, currentLocation.longitude, marketplaceProducts[0].author.profile.latitude, marketplaceProducts[0].author.profile.longitude) }}</span></span>  
            <br>
            <f7-button v-if="marketplaceProducts.length > 0 && marketplaceProducts[0].author.id != user.id" @click="showActionSheet" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left margin-small-top" large>Hubungi Penjual</f7-button>          
        </f7-block>

        <f7-block-title class="padding-small font-bold">Barang/Jasa yang dijual</f7-block-title>
        <f7-block v-if="!productLoading && marketplaceProducts.length > 0">
            <f7-list class="no-margin-top" media-list no-hairlines>
                <f7-list-item
                    v-for="(item, index) in marketplaceProducts"
                    :key="index"
                    :link="`/marketplace/product/${item.id}/`"
                >
                    <img v-if="item.medias.length > 0" :src="item.medias[0].url.small" width="48" height="48" class="img-circle" slot="media"/>
                    <img v-else :src="require('../assets/no-photo.jpg')" width="48" class="img-circle" slot="media">
                    <div slot="title">{{ item.title }}</div>
                    <div slot="after-title" v-if="item.author.profile.latitude != null && item.author.profile.longitude != null">
                        <f7-icon f7="placemark" size="18px" color="pink"></f7-icon> <span class="distance">{{ distance(currentLocation.latitude, currentLocation.longitude, item.author.profile.latitude, item.author.profile.longitude) }}</span>
                    </div>
                    <div slot="subtitle">
                        <div v-if="item.discount > 0">
                            <small class="display-block">
                                <s class="color-red">Rp {{ item.price.format(0,0,'.',',') }}</s>
                            </small>
                            <small class="display-block">Rp {{ calculateDiscount(item.price, item.discount).format(0,0,'.',',') }} / {{ item.unit.name }}</small>
                        </div>
                        <div v-else>
                            <small class="display-block">Rp {{ item.price.format(0,0,'.',',') }} / {{ item.unit.name }}</small>
                        </div>
                    </div>
                    <div slot="text"><small>{{ item.category.name }}</small></div>
                </f7-list-item>            
            </f7-list>
        </f7-block>
        <f7-block v-else-if="!productLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="remove_shopping_cart" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
		<f7-list media-list no-hairlines v-else-if="productLoading">
            <f7-list-item
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Lorem ipsum dolor sit amet"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, distance } from '../js/utils';
export default {
    name: 'MarketplaceStore',
    data(){
        return {
            productLoading: true,
            allowInfinite: true,
            showPreloader: true,
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('chat', ['chat']),
		...mapGetters('product', [
            'allmedias',
            'marketplaceProducts',
            'pagination'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    methods: {
        dateFormat,
        distance,
        calculateDiscount(price, discount){
            return price - ((price * discount) / 100);
        },
        getProducts(page, loadmore){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('product/getProducts', {
                author: self.$f7route.params.id,
                page: page,
                perpage: 25,
                pageName: 'marketplace',
                loadmore: loadmore,
                only: 'id,title,slug,description,minorder,price,delivery_cost,discount,isdeliverable,isnegotiable,category.id,category.name,category.slug,created,updated,unit.id,unit.name,unit.symbol,author.id,author.profile.fullname,author.profile.store_name,author.profile.store_about,author.profile.store_open,author.profile.store_close,author.profile.latitude,author.profile.longitude,medias'
            }).then(() => {
                self.showPreloader = self.pagination.has_next;
                self.productLoading = false;
                self.photoBrowserInit();
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            self.getProducts(1, false);
        },
        photoBrowserInit(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            if(self.allmedias.length > 0){
                let medias = self.allmedias.map((x) => x.url.original);
                let photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                });

                $$(document).on('click', '.store-has-browser', function(){
                    photoBrowser.open();
                });
            }
        },
        showActionSheet(){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: self.marketplaceProducts[0].author.profile.store_name != null ? self.marketplaceProducts[0].author.profile.store_name : self.marketplaceProducts[0].author.profile.fullname,
                label: true
            }, {
                text: 'Panggilan Telp',
                close: true,
                onClick: function(actions, e){
                    location.href = "tel:"+self.marketplaceProducts[0].author.profile.phone.replace('0','+62');
                }
            }, {
                text: 'Chat',
                close: true,
                onClick: function(actions, e){
                    app.preloader.show('green');
                    self.$store.dispatch('chat/createChat', {
                        recipient_id: self.marketplaceProducts[0].author.id
                    }).then((response)=>{
                        app.preloader.hide();
                        setTimeout(()=>{
                            self.$f7router.navigate('/chat/'+self.chat.id+'/messages/', {
                                ignoreCache: true
                            });
                        }, 100);
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        },
        onPageRefresh(e, done){
            const self = this;

            if(self.currentLocation != null){
                self.getProducts(1, false);
                done();
            }else{
                self.productLoading = false;
				self.showPreloader = false;
            }
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;
            setTimeout(()=>{
                if(self.pagination.has_next){                
                    self.getProducts(self.pagination.page + 1, true);
                    self.allowInfinite = true;
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
    }
}
</script>
